package data;

use strict;

use vars qw( $data @cntkeys @sumkeys @bytkeys );

*data = *main::data;

print "Saving data one-dimensional (simple) <parser/one_dimensional.pm>\n" if $main::debug;

sub init
{
	my %init_data = @_;

	foreach my $key (sort (keys %init_data))
	{
		if (defined $main::config->{'print'}{lc ($key)})
		{
			if (lc ($init_data{$key}) eq 'sum') { push (@sumkeys, $key); }
			# other types go here
			elsif (lc ($init_data{$key}) eq 'byte') { push (@bytkeys, $key); }
			elsif (lc ($init_data{$key}) eq 'count') { push (@cntkeys, $key); }
			else
			{
				warn "Unknown type \"" . $init_data{$key} . "\" for key $key, assuming 'count'\n";
				push (@cntkeys, $key);
			}
		}
	}
}

sub save
{
	my $hash = shift;
	my ($key, $val);

	foreach $key (@cntkeys)
	{
		$val = $hash->{$key} or next;

		++$data->{$key}{$val};
	}
	foreach $key (@sumkeys, @bytkeys)
	{
		$val = $hash->{$key} or next;
		
		$data->{'General'}{$key} += $val;
	}
}

1;
